'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

// Transform:
// eval(script); --> eval(__proc$Script(script));

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.CallExpression],

    condition: function condition(node) {
        if (!node.arguments.length) return false;

        // eval()
        if (node.callee.type === _esotope.Syntax.Identifier && node.callee.name === 'eval') return true;

        // obj.eval(), obj['eval'](),
        return node.callee.type === _esotope.Syntax.MemberExpression && (node.callee.property.name || node.callee.property.value) === 'eval';
    },

    run: function run(node) {
        node.arguments[0] = (0, _nodeBuilder.createProcessScriptMethCall)(node.arguments[0]);

        return null;
    }
};
module.exports = exports['default'];