'use strict';

exports.__esModule = true;

var _esotope = require('../tools/esotope');

var _nodeBuilder = require('../node-builder');

// Transform:
// for(obj[prop] in src), for(obj.prop in src) -->
// for(var __set$temp in src) { obj[prop] = __set$temp; }

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.ForInStatement],

    condition: function condition(node) {
        return node.left.type === _esotope.Syntax.MemberExpression;
    },

    run: function run(node) {
        var tempVarAst = (0, _nodeBuilder.createTempVarIdentifier)();

        node.body.body.unshift((0, _nodeBuilder.createAssignmentExprStmt)(node.left, tempVarAst));

        node.left = (0, _nodeBuilder.createVarDeclaration)(tempVarAst);

        return null;
    }
};
module.exports = exports['default'];