'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

// Transform:
// new Function(params..., body); -->
// new Function(params..., __proc$Script(body));

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.NewExpression],

    condition: function condition(node) {
        return node.callee.name === 'Function' && node.arguments.length;
    },

    run: function run(node) {
        var lastArgIndex = node.arguments.length - 1;

        node.arguments[lastArgIndex] = (0, _nodeBuilder.createProcessScriptMethCall)(node.arguments[lastArgIndex]);

        return null;
    }
};
module.exports = exports['default'];