'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

// Transform:
// location.field; location[field] -->
// __get$Loc(location).field; __get$Loc(location)[field];

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.MemberExpression],

    condition: function condition(node, parent) {
        // Skip: for(location.field in obj)
        if (parent.type === _esotope.Syntax.ForInStatement && parent.left === node) return false;

        return node.object.name === 'location';
    },

    run: function run(node) {
        node.object = (0, _nodeBuilder.createLocationGetWrapper)();

        return null;
    }
};
module.exports = exports['default'];